/*
Declare a SinglyLinkedList2 object whose elements come from the same
Student class.
*/

public class SinglyLinkedListExample
{
    public static void main(String[] args)
    {
        new SinglyLinkedListExample().run();
    } // method main

    public void run() {
    	Student s1 = new Student ("Jones", 3.17),
	    s2 = new Student ("Smith", 3.82), 
	    s3 = new Student ("Jones", 3.4),
	    s4 = new Student ("Anne", 3.4);
        SinglyLinkedList2<Student> list = new SinglyLinkedList2<Student>();
	list.add(s1);
	list.add(s2);
	list.add(s3);	
	list.add(s4);

    System.out.println("List1: " + list);
    System.out.println("La lista contiene " + list.size() + " elementi");
          
    list.removeLast();
    list.removeLast();
    System.out.println("\nDopo due cancellazioni in coda:\n"+list);
    System.out.println("La lista contiene " + list.size() + " elementi");

    
    list.add(1,s3);
    System.out.println("\nDopo un inserimento in posizione 1:\n"+list);
    System.out.println("La lista contiene " + list.size() + " elementi");

    list.addFirst(s4);
    System.out.println("\nDopo un inserimento in posizione 0:\n"+list);
    System.out.println("La lista contiene " + list.size() + " elementi");
    
    Student s5 = new Student ("Smith", 3.82);
    System.out.println("\nLa lista contiene lo studente (Smith,3.82)? " 
            + list.contains(s5) );
    
    // Verifica uguaglianza
    SinglyLinkedList2<Student> list2 = new SinglyLinkedList2<Student>();
    list2.add(s4);
    list2.add(s1);
    list2.add(s3);
    list2.add(s2);

    System.out.println("\nList2: " + list2); 

    System.out.println("\nLe liste sono uguali (equals())? " + list.equals(list2));
    System.out.println("Le liste sono uguali (equalsRec())? " + list.equalsRec(list2));
    
    
    System.out.println("\nList3 (Reverse List2):\n" + list2.reverse());
    System.out.println("\nList2 e' preservata:\n " + list2); 
    
    list2.reverseThisList();
    System.out.println("\nReverse List2:\n" + list2);
    
    list2.add(new Student("Charles", 4.1));
    System.out.println("\nDopo un inserimento in ultima posizione:\n" + list2);
    

    } // method run

} // class 